﻿Namespace imaging
    Public Class ColorReplacer
        Inherits System.ComponentModel.Component
#Region "properties"

        Private start As Color

        Private last As Color

        Private pic As Image

        Public Property CurrentColor() As Color
            Get
                Return start
            End Get
            Set(ByVal value As Color)
                start = value
            End Set
        End Property

        Public Property NewColor() As Color
            Get
                Return last
            End Get
            Set(ByVal value As Color)
                last = value
            End Set
        End Property

        Public Property image() As Image
            Get
                Return pic
            End Get
            Set(ByVal value As Image)
                pic = value
            End Set
        End Property

        Public EditedPoints() As Point

        Private Property rect() As Rectangle
            Get
                Dim r As New Rectangle(0, 0, image.Width, image.Height)
                Return r
            End Get
            Set(ByVal value As Rectangle)

            End Set
        End Property

#End Region
#Region "functions"

        Public Function PixelSearch() As Point()
            Try

                Dim myBitmap As New Bitmap(image)
                Dim testColor As Color
                Dim myPoint(0) As Point
                Dim i As Integer = 0
                For x As Integer = rect.X To rect.Right - 1
                    For y As Integer = rect.Y To rect.Bottom - 1
                        testColor = myBitmap.GetPixel(x, y)
                        If testColor.ToArgb = CurrentColor.ToArgb Then
                            Array.Resize(myPoint, i + 1)
                            myPoint(i) = New Point(x, y)
                            i += 1
                            Continue For
                        Else
                            Continue For
                        End If
                    Next
                Next
                Return myPoint
            Catch ex As Exception
                Return Nothing
            End Try
        End Function

        Public Function RunReplace(ByVal save As Boolean, Optional ByVal SaveTo As String = "") As Image
            Try

                EditedPoints = PixelSearch()
                Dim i As Integer = 0
                Dim bit As New Bitmap(image)
                Do Until i = EditedPoints.Count
                    bit.SetPixel(EditedPoints(i).X, EditedPoints(i).Y, NewColor)
                    i += 1
                Loop
                If EditedPoints.Count > 1 And save = True Then
                    bit.Save(SaveTo)
                End If
                Return bit
            Catch ex As Exception
                Return image
            End Try
        End Function

#End Region
    End Class
End Namespace