﻿Namespace GradientControls.styles
    Public Class style
        Private p As Collections.Generic.List(Of Single)
        Private ang As Integer
        Private colo As New Collections.Generic.List(Of Color)(0)
        Private Const z As Single = 0


        <System.ComponentModel.Description("The array of positions as a decimal, E.G. 0.75, that corresponds to the gradient color of the same index in the multicolor gradient."), _
        System.ComponentModel.Category("Appearance")> _
        Public Property GradientPositions() As Collections.Generic.List(Of Single)
            Get
                Return p
            End Get
            Set(ByVal value As Collections.Generic.List(Of Single))
                If value Is Nothing Then
                Else
                    If value.Count = 0 Then
                        p = value
                    Else
                        If value.Max <= 1 And value.Min >= 0 Then
                            p = value
                        End If
                    End If
                End If
            End Set
        End Property

        <System.ComponentModel.Description("A generic list of colors that make up the multicolor gradient."), _
        System.ComponentModel.Category("Appearance")> _
        Public Property GradientColorArray() As Collections.Generic.List(Of Color)
            Get
                Return colo
            End Get
            Set(ByVal value As Collections.Generic.List(Of Color))
                colo = value
            End Set
        End Property

        <System.ComponentModel.Description("The angle to rotate the gradient."), _
        System.ComponentModel.DefaultValue(90), _
        System.ComponentModel.Category("Appearance")> _
        Public Property GradientAngle() As Integer
            Get
                Return ang
            End Get
            Set(ByVal value As Integer)
                If -1 < value < 256 Then
                    ang = value
                Else
                    ang = 90
                End If
            End Set
        End Property

        Public Sub New(ByVal GradientColor As List(Of Color), ByVal GradientPosition As List(Of Single), Optional ByVal angle As Integer = 90)
            GradientColorArray = New List(Of Color)(0)
            GradientPositions = New List(Of Single)(0)
            GradientAngle = angle
        End Sub
    End Class
End Namespace
