﻿Namespace Imaging
    ''' <summary>
    ''' Helps you to find and change certain colors.
    ''' </summary>
    ''' <remarks>To testers. Needs a reworked usage system and performance testing.</remarks>
    Public Class ColorReplacer
        Inherits System.ComponentModel.Component
#Region "properties"

        Private start As Color

        Private last As Color

        Private pic As Image

        ''' <summary>
        ''' the color to search for.
        ''' </summary>
        Public Property CurrentColor() As Color
            Get
                Return start
            End Get
            Set(ByVal value As Color)
                start = value
            End Set
        End Property

        ''' <summary>
        ''' The color to change to
        ''' </summary>
        Public Property NewColor() As Color
            Get
                Return last
            End Get
            Set(ByVal value As Color)
                last = value
            End Set
        End Property

        ''' <summary>
        ''' The edited image and/or the image to be edited.
        ''' </summary>
        Public Property image() As Image
            Get
                Return pic
            End Get
            Set(ByVal value As Image)
                pic = value
            End Set
        End Property

        Public EditedPoints() As Point

        Private ReadOnly Property rect() As Rectangle
            Get
                Dim r As New Rectangle(0, 0, image.Width, image.Height)
                Return r
            End Get
        End Property

#End Region
#Region "functions"
        ''' <summary>
        ''' Returns an array of all points with a color eqal to current color.
        ''' </summary>
        ''' <returns>Point()</returns>
        Public Function PixelSearch() As Point()
            Try

                Dim myBitmap As New Bitmap(image)
                Dim testColor As Color
                Dim myPoint(0) As Point
                Dim i As Integer = 0
                For x As Integer = rect.X To rect.Right - 1
                    For y As Integer = rect.Y To rect.Bottom - 1
                        testColor = myBitmap.GetPixel(x, y)
                        If testColor.ToArgb = CurrentColor.ToArgb Then
                            Array.Resize(myPoint, i + 1)
                            myPoint(i) = New Point(x, y)
                            i += 1
                            Continue For
                        Else
                            Continue For
                        End If
                    Next
                Next
                Return myPoint
            Catch ex As Exception
                Return Nothing
            End Try
        End Function

        ''' <summary>
        ''' Changes the color of all points whose color is CurrentColor to NewColor.
        ''' </summary>
        ''' <param name="SaveTo">the path to save the image to. NOTE: Include file name and extention.</param>
        ''' <returns>Image</returns>
        ''' <remarks>Needs testing</remarks>
        Public Function RunReplace(Optional ByVal SaveTo As String = "") As Image
            Try

                EditedPoints = PixelSearch()
                Dim i As Integer = 0
                Dim bit As New Bitmap(image)
                Do Until i = EditedPoints.Count
                    bit.SetPixel(EditedPoints(i).X, EditedPoints(i).Y, NewColor)
                    i += 1
                Loop
                If EditedPoints.Count > 1 And SaveTo <> "" Then
                    bit.Save(SaveTo)
                End If
                image = bit
                Return bit
            Catch ex As Exception
                Return image
            End Try
        End Function

#End Region
    End Class
End Namespace