﻿Namespace controls
    <System.ComponentModel.Description("a button that shows a specific image during button states")> _
    Public Class button
        Inherits System.Windows.Forms.Button
        Private pressed_state As Image
        Private normal_state As Image
        Private hilighted_state As Image
        <System.ComponentModel.Description("The image that displays when the control is pressed")> _
        Public Property pressed_image() As Image
            Get
                Return pressed_state
            End Get
            Set(ByVal value As Image)
                pressed_state = value
                Me.BackgroundImage = value
            End Set
        End Property


        <System.ComponentModel.Description("The image that displays when the control is in a normal state")> _
        Public Property normal_image() As Image
            Get
                Return normal_state
            End Get
            Set(ByVal value As Image)
                normal_state = value
            End Set
        End Property

        <System.ComponentModel.Description("The image that displays when the control is highlited")> _
        Public Property hilighted_image() As Image
            Get
                Return hilighted_state
            End Get
            Set(ByVal value As Image)
                hilighted_state = value
            End Set
        End Property


        Private focused_state As Image
        <System.ComponentModel.Description("The image that displays when the control is focused")> _
        Public Property focused_image() As Image
            Get
                Return focused_state
            End Get
            Set(ByVal value As Image)
                focused_state = value
            End Set
        End Property

        Private Sub button_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseDown
            Me.BackgroundImage = pressed_image
        End Sub

        Private Sub button_MouseEnter(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.MouseEnter
            Me.BackgroundImage = hilighted_image
        End Sub

        Private Sub button_MouseHover(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.MouseHover
            Me.BackgroundImage = hilighted_image
        End Sub

        Private Sub button_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.MouseLeave
            Me.BackgroundImage = normal_image
        End Sub

        Private Sub button_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseUp
            Me.BackgroundImage = focused_image
        End Sub
    End Class
End Namespace