﻿Namespace Timers
    ''' <summary>
    ''' this control is a timer with multipule events to aid in creating an animation
    ''' </summary>
    Public Class CustomAnimation
        Inherits System.Windows.Forms.Timer
        Dim heightC As Integer = 0
        Dim widthC As Integer = 0
        Dim image As Integer = 0
        ''' <summary>
        ''' This sub changes the height of a control by a specific amount
        ''' </summary>
        ''' <param name="control">This is control that will be affected</param>
        ''' <param name="changeBY">This is amount in pixels that the height will change to increase make it positive to decrease negative</param>
        ''' <param name="changeCenter">If true the location will change to keep the center the same NOTE: odd numbers WILL have strange effects</param>
        Public Sub HeightAnimator(ByVal control As Control, ByVal changeBY As Integer, ByVal changeCenter As Boolean)
            heightC += changeBY \ 2
            control.Height += changeBY
            If changeCenter = True Then
                If changeBY / 2 <= heightC Then
                    control.Top -= heightC
                    heightC = 0
                End If
            End If
        End Sub
        ''' <summary>
        ''' This sub changes the width of a control by a specific amount
        ''' </summary>
        ''' <param name="control">This is control that will be affected</param>
        ''' <param name="changeBY">This is amount in pixels that the width will change to increase make it positive to decrease negative</param>
        ''' <param name="changeCenter">If true the location will change to keep the center the same NOTE: odd numbers WILL have strange effects</param>
        Public Sub WidthAnimator(ByVal control As Control, ByVal changeBY As Integer, ByVal changeCenter As Boolean)
            widthC += changeBY \ 2
            control.Width += changeBY
            If changeCenter = True Then
                If changeBY / 2 <= widthC Then
                    control.Left -= widthC
                    widthC = 0
                End If
            End If
        End Sub
        ''' <summary>
        ''' Changes the color of a control by a regular amount
        ''' </summary>
        ''' <param name="changeR">The amount to change the red value</param>
        ''' <param name="changeG">The amount to change the green value</param>
        ''' <param name="changeB">The amount to change the blue value</param>
        ''' <param name="ControlColor">The property of the cotrol to change E.G. control.backcolor</param>
        Public Sub color(ByVal changeR As Integer, ByVal changeG As Integer, ByVal changeB As Integer, ByVal ControlColor As Color)
            If ControlColor.R + changeR < 256 And ControlColor.R + changeR >= 0 Then
                ControlColor = System.Drawing.Color.FromArgb(ControlColor.R + changeR, ControlColor.G, ControlColor.B)

            End If

            If ControlColor.B + changeB <= 255 And ControlColor.B + changeB >= 0 Then
                ControlColor = System.Drawing.Color.FromArgb(ControlColor.R, ControlColor.G, ControlColor.B + changeB)
            End If

            If ControlColor.G + changeG <= 255 And ControlColor.G + changeG >= 0 Then
                ControlColor = System.Drawing.Color.FromArgb(ControlColor.R, ControlColor.G + changeG, ControlColor.B)
            End If

        End Sub
        ''' <summary>
        ''' Places images from a image list to a specified PictureBox and raises the image index every call
        ''' </summary>
        ''' <param name="control">The control to animate</param>
        ''' <param name="imagelist">The ImageList to pull from</param>
        Public Sub image_animator(ByVal control As Control, ByVal imagelist As ImageList)

            If image < imagelist.Images.Count Then
                control.BackgroundImage = imagelist.Images.Item(image)
                image += 1
            Else
                image = 0
            End If


        End Sub



    End Class
End Namespace